close all

for temps=0.5
    temps

    %calcule les matrices camras 1 et 2
    c_1=calc_c(Tc_1,omc_1,fc,cc);
    c_2=calc_c(Tc_2,omc_2,fc,cc);

    C3_1=c_1(:,1:3); % recupere les 3 premieres colones, sous matrice 3*3 a gauche de c_1
    c4_1=c_1(:,4); % 4 colone de c_1

    C3_2=c_2(:,1:3); % recupere les 3 premieres colones, sous matrice 3*3 a gauche de c_2
    c4_2=c_2(:,4); % 4 colone de c_2

    %positions des centres optiques
    L1=inv(C3_1)*c4_1;
    L2=inv(C3_2)*c4_2;

    %position du centre optique de la camra 3
    L3=L1+temps*(L2-L1);

    %pour les rotations, c'est lgerement plus complexe
    %convertit les rotations en matrices
    R1=rodrigues(omc_1);
    R2=rodrigues(omc_2);

    %calcule la matrice correspondant  la rotation entre les 2 vues
    Rd=R1'*R2;
    %calcule le vecteur correspondant  la rotation complete
    omd=rodrigues(Rd);

    %calcule le vecteur correspondant  la rotation intermediaire relative
    % R1
    omd2=temps*omd;
    %calcule la matrice correspondante relative  R1
    Rd2=rodrigues(omd2);

    %calcule la matrice rotation intermediaire par rapport au repere de
    %travail
    R3=R1*Rd2;
    %calcule le vecteur correspondant  la rotation intermediaire par 
    %rapport au repere de travail
    omc_3=rodrigues(R3);
    
    %calcule la translation exprime dans le repre camra
    Tc_3=R3*L3;

    %calcule la matrice camra 3
    c_3=calc_c(Tc_3,omc_3,fc,cc);
    
    %changement des paramtres intrinsques
    %par exemple pour augmenter la focale
    %c_3=calc_c(Tc_3,omc_3,fc*1.5,cc);
    %par exemple pour dplacer le point principal
    %c_3=calc_c(Tc_3,omc_3,fc,cc+[300;-100]);


    %lit les 2 images
    image1=imread('imaobj1_rect.jpg','jpeg');
    image2=imread('imaobj2_rect.jpg','jpeg');

    %calcule des images en niveau de gris
    image1=0.33*image1(:,:,1)+0.33*image1(:,:,2)+0.33*image1(:,:,3);
    image2=0.33*image2(:,:,1)+0.33*image2(:,:,2)+0.33*image2(:,:,3);

    

    %pour avoir un fond avec les images 1 et 2 mixes
    %imagesynthese=0.5*image1+0.5*image2;
    
    %pour avoir un fond noir
    imagesynthese=0*image1;


    [nl,nc,nn]=size(image1);
    imout=zeros(nl,nc);


    %nombre de faces de l'objet
    nbfaces=size(faces,1);
%commencer avec la premire face de l'objet, puis commenter la ligne
%suivante pour traiter toutes les faces
   nbfaces=1

    for n=1:nbfaces


        if faces(n,1)==0
            break;
        end

        TailleTexture=256;
        imtexture=zeros(TailleTexture,TailleTexture);

      H=eye(3); %par defaut, copie des pixels sources vers l'image de destination

     % A COMPLETER: 
     
     %Calculer les projections des points de cette face dans l'image 1
     %et l'homographie H avec l'image de texture de dimension
     %TailleTexture*TailleTexture
     
     
     
        %calcule l'image de texture en fonction de l'homographie fournie
        [imtexture]=CalculeImageHomographie(H,imtexture,TailleTexture,TailleTexture,image1,nl,nc);

        
        %Affichage de l'image de texture
        figure(1)
        clf
        hold on
        title('Image de texture calcule')
        imagesc(imtexture)
        colormap('Gray')
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
        
        H2=eye(3); %par defaut, copie des pixels sources vers l'image de destination

     % A COMPLETER: 
        
     %Calculer les projections des points de cette face dans l'image
     %intermediaire et l'homographie H2 avec l'image de texture de dimension
     %TailleTexture*TailleTexture 
     
     
     
     
        [imagesynthese]=CalculeImageHomographie(H,imagesynthese,nl,nc,imtexture,TailleTexture,TailleTexture);


    end

    figure(2)
    hold on
    axis ij
    title('image gnre');
    imagesc(imagesynthese);
    colormap('Gray')
  
    %calcule les projections des points et affiche des croix sur l'image
    %synthtise
    plot([0;800],[0;600],'g+');
    nbpts=size(points_3d,1);
    for n=1:nbpts
        %plot3(points_3d(n,1), points_3d(n,2),points_3d(n,3),'g+');
        M=[points_3d(n,1), points_3d(n,2),points_3d(n,3),1]';
        m=c_3*M;
        m=m/m(3);
        plot(m(1),m(2),'g+');
    end

    %sauvegarde l'image avec un nom correspondant au temps
    nomfichier=sprintf('video_t%f.jpg',temps)
    imwrite(imagesynthese,nomfichier,'jpg');

end